--freemarker template

<#if SQLdialect='Postgres'>

drop table if exists tmp_execution;

</#if>


create table tmp_execution(	tid INTEGER  not null, 
name varchar(255)  not null, 
userinfo_id INTEGER , 
userinfo_str VARCHAR(255) , 
maskeninfo_id INTEGER , 
is_active smallint  default 1  not null, 
stylesheet_id INTEGER  default 1 , 
stylesheet_str VARCHAR(255) , 
contenttype VARCHAR(255) , 
output_filename VARCHAR(255) , 
systeminfo_id INTEGER ,
field_value varchar(255),
field_values varchar(255)
)
;

insert into tmp_execution(tid,
       name,
       userinfo_id,
       maskeninfo_id,
       is_active,
       stylesheet_id,
       contenttype,
       output_filename,
       systeminfo_id,
       field_values)



SELECT E.tid,
       E.name,
       E.userinfo_id,
       E.maskeninfo_id,
       E.is_active,
       E.stylesheet_id,
       E.contenttype,
       E.output_filename,
       E.systeminfo_id,
       ''
FROM qa_mask_execution E
where E.is_active=1
 ;

create temp table tmp_inserted(
mask_execution_id integer,
qa_mask_field_sel_tid integer,
do_insert smallint);

<#list 1..10 as i>


insert into tmp_inserted(mask_execution_id ,
do_insert,
qa_mask_field_sel_tid)
select S.mask_execution_id,1,min(S.tid)
from felderinfo F, qa_mask_field_sel S
where F.tid=S.felderinfo_id
and S.is_active=1
and '' || S.mask_execution_id || '_' || S.tid not in (
select '' || T.mask_execution_id || '_' || T.qa_mask_field_sel_tid
from tmp_inserted T)
group by 1,2
;

 
update tmp_execution set field_value=(select trim(F.name) || '=' || trim(S.field_value)
from felderinfo F, qa_mask_field_sel S, tmp_inserted T
where T.mask_execution_id=S.mask_execution_id
and T.mask_execution_id=tmp_execution.tid
and F.tid=S.felderinfo_id
and S.is_active=1
and S.tid=T.qa_mask_field_sel_tid
and T.do_insert=1
)
;
update tmp_inserted set do_insert=0;
update tmp_execution set field_values=field_values || trim(string_not_null('&' || field_value));


</#list> 

drop table tmp_inserted;

update tmp_execution set stylesheet_str='tabelle_xml.xsl' 
--derzeit noch fest verdrahtet xml
--(select trim(S.filename)
--from sx_stylesheets S
--where S.tid=tmp_execution.stylesheet_id)
;

update tmp_execution set userinfo_str=(select trim(U.benutzer)
from userinfo U
where U.tid=tmp_execution.userinfo_id);

--java -cp "$JDBC_CLASSPATH" $JAVA_OPTS de.superx.bin.ExecuteMask -tid:16000 -out:test.pdf -user:admin "-params:Köpfe oder Fälle ?=1=1&Stichtag=1&stylesheet=tabelle_fo_pdf.xsl&contenttype=application/pdf" -logger:$SUPERX_DIR/db/conf/logging.properties

--select 'java -cp "$JDBC_CLASSPATH"  $JAVA_OPTS de.superx.bin.ExecuteMask -tid:' || maskeninfo_id
--|| ' -out:' || output_filename || ' -user:' || userinfo_str || ' "-params:1=1'|| field_values || '&&stylesheet=' || stylesheet_str || '&contenttype=' || contenttype || '"  -logger:$SUPERX_DIR/db/conf/logging.properties'
--from tmp_execution;

--drop table tmp_execution;


