-- Profil für Vergleich ASTAT
-- kann per Hilfsmaske eingespielt werden, wenn QA-Modul installiert
--freemarker template
<#assign profiles = [
{"name":"Vergleich Studierende ASTAT (Fach/Abschluss) Stichtag tagesakt.",
"uniquename":"sos_stud_astat_stg_abschluss_s0",
"table_1":"qa_sos_stg_aggr_astat",
"table_1_caption":"Studierende ASTAT (ohne Exmatr.)",
"table_1_filter":"kz_rueck_beur_ein !=5",
"table_2":"qa_sos_stg_aggr_int",
"table_2_caption":"Studierende (intern) tagesaktuell",
"table_2_filter":"hrst !=4 and stichtag in (select I.tid from sos_stichtag I where appl_key in (''0''))",
"systeminfo_id":"7"}
] />
<#assign pruefungen = [
{"name":"Gesamtzahl der Fälle","whereclause":"","priority":"A","aggregationfield":"matrikel_nr","aggregationfunction":"count"},
{"name":"Gesamtzahl der Köpfe","whereclause":"studiengang_nr=1 and fach_nr=1","priority":"A","aggregationfield":"matrikel_nr","aggregationfunction":"count"}
] />
<#assign groupbycol = {"name":"sem_rueck_beur_ein","caption":"Semester"} />
<#assign idcols = [
{"name":"sem_rueck_beur_ein","caption":"Semester"},
{"name":"matrikel_nr","caption":"Matrikel-Nr."},
   {"name":"stg","caption":"Fach"  },
   {"name":"abschluss","caption":"Abschluss"  }
] />
<#assign ord=0 />
<#assign  fields = [
{"name":"geschlecht","priority":"A","caption":"Geschlecht" },
{"name":"ca12_staat","priority":"A","caption":"Staatsangehörigkeit"  },
{"name":"kz_rueck_beur_ein","priority":"A","caption":"Status"  },
{"name":"hrst","priority":"A","caption":"Hörerstatus"  },
{"name":"fach_sem_zahl","priority":"A","caption":"Fachsemester"  },
{"name":"studiengang_nr","priority":"A","caption":"Studiengang-Nr."},
{"name":"fach_nr","priority":"A","caption":"Fachnr."}
 
 ] />
 
--Der folgende Code ist generisch:
<#foreach profile  in profiles>
delete from qa_tablecomp_aggregation
where qa_tablecomp_profile_id in (select P.tid from qa_tablecomp_profile P
       where P.uniquename='${profile.uniquename}')
       ;
delete from qa_tablecomp_groupby
where qa_tablecomp_profile_id in (select P.tid from qa_tablecomp_profile P
       where P.uniquename='${profile.uniquename}')
       ;
delete from qa_tablecomp_idcol
where qa_tablecomp_profile_id in (select P.tid from qa_tablecomp_profile P
       where P.uniquename='${profile.uniquename}')
       ;
delete from qa_tablecomp_field
where qa_tablecomp_profile_id in (select P.tid from qa_tablecomp_profile P
       where P.uniquename='${profile.uniquename}')
       ;
delete from qa_tablecomp_profile
where  uniquename='${profile.uniquename}'
       ;
insert into qa_tablecomp_profile( name,
       uniquename,
       table_1,
       table_1_caption,
       table_1_filter,
       table_2,
       table_2_caption,
       table_2_filter,
       is_active,
       systeminfo_id)
       select '${profile.name}',
       '${profile.uniquename}',
       '${profile.table_1}',
       '${profile.table_1_caption}',
       '${profile.table_1_filter}',
       '${profile.table_2}',
       '${profile.table_2_caption}',
       '${profile.table_2_filter}',
      1,
       ${profile.systeminfo_id}
       from xdummy;
 
<#assign ord=0 />
<#foreach pruefung  in pruefungen>
insert into qa_tablecomp_aggregation(
qa_tablecomp_profile_id,
       name,
       whereclause,
       is_active,
       priority,
       aggregationfield,
       aggregationfunction
)
select  tid,
'${pruefung.name}',
       '${pruefung.whereclause}',
       1,
       '${pruefung.priority}',
       '${pruefung.aggregationfield}',
       '${pruefung.aggregationfunction}'
       from qa_tablecomp_profile
       where uniquename='${profile.uniquename}';
</#foreach>
insert into qa_tablecomp_groupby( qa_tablecomp_profile_id,
       fieldname,
       fieldcaption
)
select  tid,
'${groupbycol.name}',
'${groupbycol.caption}'
       from qa_tablecomp_profile
       where uniquename='${profile.uniquename}';
       
<#foreach idcol  in idcols>
insert into qa_tablecomp_idcol( qa_tablecomp_profile_id,
       fieldname,
       fieldcaption
)
select  tid,
'${idcol.name}',
'${idcol.caption}'
       from qa_tablecomp_profile
       where uniquename='${profile.uniquename}';
</#foreach>
<#foreach field  in fields>
<#assign ord=ord+1 />
insert into qa_tablecomp_field(
 qa_tablecomp_profile_id,
       name,
       caption,
       priority,
       sortnr
)
select  tid,
'${field.name}',
'${field.caption}',
       '${field.priority}',
       ${ord}
       from qa_tablecomp_profile
       where uniquename='${profile.uniquename}';
</#foreach>
--Ende Profil
</#foreach>